PROBLEM LINKS:
Practice
Contest
DIFFICULTY:
Easy
PREREQUISITES:
Heaps
PROBLEM:
You’re given an online stream of numbers. At any point of time if K numbers have already appeared, you need to find out floor(K/3)th largest number.
QUICK EXPLANATION:
Maintain two heaps - one min heap for top floor(K/3) numbers and other max heap for all remaining numbers.
DETAILED EXPLANATION:
We can maintain two different heaps - one min heap for top 1/3th of votes and
one max heap for all other votes. Once we have this, we can simulate actual
voting itself. The reason is after every vote, at maximum 1 vote moves between
the heaps.
To understand this, let’s say that at some point of time we’ve x votes in top heap
and N - x votes in other heap. If a new vote comes push it in one of the two halves
by comparing its value to the lowest value in top heap. Now assume it went in top
heap. Number of votes in top heap might be more than floor( (N+1) / 3) now in which case we’d need to transfer some numbers to the other heap. But difference
is only of 1 vote as number of votes in top heap <= 1 + floor(N/3) and hence only 1 vote needs
to goto bottom heap. That one vote has to be the minimum value of this heap.
By similar argument, had the vote gone to bottom heap, again only its topmost value
need to be transfered to top heap, if at all.
At any query, all we have to do is find out the smallest value from top heap and print it.
Complexity of our solution is O(N log N) as we take O(log N) time per query.
SETTER’S SOLUTION:
Can be found here.
TESTER’S SOLUTION:
Can be found here.
RELATED PROBLEMS:
Spoj Weird Function
5 Likes
I tried the same solution with TreeSet and myInteger class to take care of the duplicates. Because it gave me TLE, I tested only insertion in one treeset, and it gave me TLE again. Why did this happen? They’re suppose to be equivalent in their complexities for insertion with the priority queue and to be balanced to get the logn… (I used fast io)
2 Likes
I had same problem with TreeSet :-/
This can also be done with MULTISET STL in C++… but just you have to careful with iterator… since iterator is only bidirectional here not random.
If anyone want more info on procedure… i can elaborate
instead of maintaining two heaps it can also be done using Treaps ( http://en.wikipedia.org/wiki/Treap )
i am not happy with codechef. When i tried with cin and cout i got TLE and when i tried with printf() and scanf() i got AC. I think Codechef should know that its a algorithmic contest not a Humpty-Dumpty Language contest…
Pathetic the setters solution shows wrong answer on submissio? Just how bad things can get for Codechef
2 Likes
What the hell man you dont even test your setter’s and tester’s solutions…
It’s true, they give wrong answer. Maybe, because the test data was changed in the contest.
It’s written in FAQ. Also there is practice problem for this… It can be worse - for example when you cannot use HashMap/HashSet or sorting in Java at CodeForces…
Hey, your right about the setter’s solution getting a “wrong answer”. However, I added a little code segment to it and resubmitted to check. I got a correct submission this time.
http://www.codechef.com/viewsolution/1180239
Can’t the simple binary search work?
Problem with binary search is, that you have to have sorted array. Let’s assume I’ll add 100.000 elements to array and then I’ll switching command 2 and command 1, so you need something like 125.000 sorts in array with size 100.000. Sort do not need to be quicksort (0(n*log(n)), probably insert sort is better (O(n)) (I do not know something better), but it is still too slow…
If no one knows why this happened, then perhaps the admin can check the test case/s where it fails (and I’m speaking only for insertion in a treeset)
i tried using multisets but i gives me tle…can u please check
http://www.codechef.com/viewsolution/1654148
@sikander_nsit - check out your loops… and check my solution… there is still optimization required !!